Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/IOM/in_out_manager.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/IOM/in_out_manager.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/IOM/in_out_manager.F90	(revision 10001)
@@ -35,5 +35,5 @@
    INTEGER       ::   nn_time0         !: initial time of day in hhmm
    INTEGER       ::   nn_leapy         !: Leap year calendar flag (0/1 or 30)
-   INTEGER       ::   nn_istate        !: initial state output flag (0/1)
+   LOGICAL       ::   ln_istate        !: initial state output flag
    INTEGER       ::   nn_write         !: model standard output frequency
    INTEGER       ::   nn_stock         !: restart file frequency
@@ -79,5 +79,4 @@
    INTEGER       ::   ndate0                      !: initial calendar date aammjj
    INTEGER       ::   nleapy                      !: Leap year calendar flag (0/1 or 30)
-   INTEGER       ::   ninist                      !: initial state output flag (0/1)
    INTEGER       ::   nwrite                      !: model standard output frequency
    INTEGER       ::   nstock                      !: restart file frequency
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/SBC/sbcice_cice.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/SBC/sbcice_cice.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/SBC/sbcice_cice.F90	(revision 10001)
@@ -205,5 +205,5 @@
          DO jl=1,ncat
             CALL cice2nemo(aicen(:,:,jl,:),a_i(:,:,jl), 'T', 1. )
-         ENDDO
+         END DO
       ENDIF
 
@@ -214,6 +214,6 @@
             fr_iu(ji,jj)=0.5*(fr_i(ji,jj)+fr_i(ji+1,jj))*umask(ji,jj,1)
             fr_iv(ji,jj)=0.5*(fr_i(ji,jj)+fr_i(ji,jj+1))*vmask(ji,jj,1)
-         ENDDO
-      ENDDO
+         END DO
+      END DO
 
       CALL lbc_lnk_multi( fr_iu , 'U', 1.,  fr_iv , 'V', 1. )
@@ -235,7 +235,7 @@
                !
                DO jk = 1,jpkm1                     ! adjust initial vertical scale factors
-                  e3t_n(:,:,jk) = e3t_0(:,:,jk)*( 1._wp + sshn(:,:)*tmask(:,:,1)/(ht_0(:,:) + 1.0 - tmask(:,:,1)) )
-                  e3t_b(:,:,jk) = e3t_0(:,:,jk)*( 1._wp + sshb(:,:)*tmask(:,:,1)/(ht_0(:,:) + 1.0 - tmask(:,:,1)) )
-               ENDDO
+                  e3t_n(:,:,jk) = e3t_0(:,:,jk) * ( 1._wp + sshn(:,:) * r1_ht_0(:,:) )
+                  e3t_b(:,:,jk) = e3t_0(:,:,jk) * ( 1._wp + sshb(:,:) * r1_ht_0(:,:) )
+               END DO
                e3t_a(:,:,:) = e3t_b(:,:,:)
                ! Reconstruction of all vertical scale factors at now and before time-steps
@@ -307,6 +307,6 @@
                ztmp(ji,jj) = 0.5 * (  fr_iu(ji,jj) * utau(ji,jj)      &
                                     + fr_iu(ji,jj+1) * utau(ji,jj+1) ) * fmask(ji,jj,1)
-            ENDDO
-         ENDDO
+            END DO
+         END DO
          CALL nemo2cice(ztmp,strax,'F', -1. )
 
@@ -317,6 +317,6 @@
                ztmp(ji,jj) = 0.5 * (  fr_iv(ji,jj) * vtau(ji,jj)      &
                                     + fr_iv(ji+1,jj) * vtau(ji+1,jj) ) * fmask(ji,jj,1)
-            ENDDO
-         ENDDO
+            END DO
+         END DO
          CALL nemo2cice(ztmp,stray,'F', -1. )
 
@@ -325,5 +325,5 @@
             DO jl=1,ncat
                ztmpn(:,:,jl)=qla_ice(:,:,1)*a_i(:,:,jl)
-            ENDDO
+            END DO
          ELSE
 ! emp_ice is set in sbc_cpl_ice_flx as sublimation-snow
@@ -332,8 +332,8 @@
             DO jj=1,jpj
                DO ji=1,jpi
-                  IF (fr_i(ji,jj).eq.0.0) THEN
+                  IF (fr_i(ji,jj) == 0._wp ) THEN
                      DO jl=1,ncat
-                        ztmpn(ji,jj,jl)=0.0
-                     ENDDO
+                        ztmpn(ji,jj,jl) = 0._wp
+                     END DO
                      ! This will then be conserved in CICE
                      ztmpn(ji,jj,1)=qla_ice(ji,jj,1)
@@ -341,8 +341,8 @@
                      DO jl=1,ncat
                         ztmpn(ji,jj,jl)=qla_ice(ji,jj,1)*a_i(ji,jj,jl)/fr_i(ji,jj)
-                     ENDDO
+                     END DO
                   ENDIF
-               ENDDO
-            ENDDO
+               END DO
+            END DO
          ENDIF
          DO jl=1,ncat
@@ -366,5 +366,5 @@
             ENDIF
             CALL nemo2cice(ztmp,fsurfn_f(:,:,jl,:),'T', 1. )
-         ENDDO
+         END DO
 
       ELSE IF (ksbc == jp_blk) THEN
@@ -437,6 +437,6 @@
          DO ji=1,jpi
             ztmp(ji,jj)=0.5*(ssu_m(ji,jj)+ssu_m(ji,jj+1))*fmask(ji,jj,1)
-         ENDDO
-      ENDDO
+         END DO
+      END DO
       CALL nemo2cice(ztmp,uocn,'F', -1. )
 
@@ -445,6 +445,6 @@
          DO ji=1,jpim1
             ztmp(ji,jj)=0.5*(ssv_m(ji,jj)+ssv_m(ji+1,jj))*fmask(ji,jj,1)
-         ENDDO
-      ENDDO
+         END DO
+      END DO
       CALL nemo2cice(ztmp,vocn,'F', -1. )
 
@@ -511,6 +511,6 @@
          DO ji=2,jpim1
             ss_iou(ji,jj) = 0.5 * ( ztmp1(ji,jj-1) + ztmp1(ji,jj) ) * umask(ji,jj,1)
-         ENDDO
-      ENDDO
+         END DO
+      END DO
       CALL lbc_lnk( ss_iou , 'U', -1. )
 
@@ -523,6 +523,6 @@
          DO ji=2,jpim1
             ss_iov(ji,jj) = 0.5 * ( ztmp1(ji-1,jj) + ztmp1(ji,jj) ) * vmask(ji,jj,1)
-         ENDDO
-      ENDDO
+         END DO
+      END DO
       CALL lbc_lnk( ss_iov , 'V', -1. )
 
@@ -609,6 +609,6 @@
          DO ji=1,jpi
             nfrzmlt(ji,jj)=MAX(nfrzmlt(ji,jj),0.0)
-         ENDDO
-      ENDDO
+         END DO
+      END DO
 
 #if defined key_cice4
@@ -627,5 +627,5 @@
          DO jl=1,ncat
             CALL cice2nemo(aicen(:,:,jl,:),a_i(:,:,jl), 'T', 1. )
-         ENDDO
+         END DO
       ENDIF
 
@@ -636,6 +636,6 @@
             fr_iu(ji,jj)=0.5*(fr_i(ji,jj)+fr_i(ji+1,jj))*umask(ji,jj,1)
             fr_iv(ji,jj)=0.5*(fr_i(ji,jj)+fr_i(ji,jj+1))*vmask(ji,jj,1)
-         ENDDO
-      ENDDO
+         END DO
+      END DO
 
       CALL lbc_lnk_multi( fr_iu , 'U', 1., fr_iv , 'V', 1. )
@@ -872,6 +872,6 @@
          DO ji=2,nx_block-1
             pc(ji,jj,1)=pn(ji-1+ji_off,jj-1+jj_off)
-         ENDDO
-      ENDDO
+         END DO
+      END DO
 
 #else
@@ -898,12 +898,12 @@
                DO ji=nldit(jn),nleit(jn)
                   png2(ji+nimppt(jn)-1,jj+njmppt(jn)-1)=png(ji,jj,jn)
-               ENDDO
-            ENDDO
-         ENDDO
+               END DO
+            END DO
+         END DO
          DO jj=1,ny_global
             DO ji=1,nx_global
                pcg(ji,jj)=png2(ji+ji_off,jj+jj_off)
-            ENDDO
-         ENDDO
+            END DO
+         END DO
       ENDIF
 
@@ -999,6 +999,6 @@
          DO ji=1,jpim1
             pn(ji,jj)=pc(ji+1-ji_off,jj+1-jj_off,1)
-         ENDDO
-      ENDDO
+         END DO
+      END DO
 
 #else
@@ -1021,7 +1021,7 @@
                DO ji=nldit(jn),nleit(jn)
                   png(ji,jj,jn)=pcg(ji+nimppt(jn)-1-ji_off,jj+njmppt(jn)-1-jj_off)
-               ENDDO
-            ENDDO
-         ENDDO
+               END DO
+            END DO
+         END DO
       ENDIF
 
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/TRA/trazdf.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/TRA/trazdf.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/TRA/trazdf.F90	(revision 10001)
@@ -175,4 +175,5 @@
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
+!!gm BUG   here e3w_a  should be used !!!!!   but then should be added in the system 
                      zwi(ji,jj,jk) = - p2dt * zwt(ji,jj,jk  ) / e3w_n(ji,jj,jk  )
                      zws(ji,jj,jk) = - p2dt * zwt(ji,jj,jk+1) / e3w_n(ji,jj,jk+1)
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/nemogcm.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/nemogcm.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/nemogcm.F90	(revision 10001)
@@ -36,4 +36,6 @@
    !!----------------------------------------------------------------------
    !!   nemo_gcm      : solve ocean dynamics, tracer, biogeochemistry and/or sea-ice
+   !!   nemo_MLF      : Modified Leap-Frog time stepping loop
+   !!   nemo_RK3      : 3rd order Runge-Kutta time stepping loop
    !!   nemo_init     : initialization of the NEMO system
    !!   nemo_ctl      : initialisation of the contol print
@@ -60,4 +62,5 @@
    USE diacfl         ! CFL diagnostics               (dia_cfl_init routine)
    USE step           ! NEMO time-stepping                 (stp     routine)
+   USE stpRK3         ! NEMO time-stepping                 (stp     routine)
    USE icbini         ! handle bergs, initialisation
    USE icbstp         ! handle bergs, calving, themodynamics and transport
@@ -123,6 +126,4 @@
       !!              Madec, 2008, internal report, IPSL.
       !!----------------------------------------------------------------------
-      INTEGER ::   istp   ! time step index
-      !!----------------------------------------------------------------------
       !
 #if defined key_agrif
@@ -152,5 +153,49 @@
       !                            !-----------------------!
       !
-      !                                               !== set the model time-step  ==!
+      IF( ln_MLF )   CALL nemo_MLF        ! Modified Leap-Frog
+      !
+      IF( ln_RK3 )   CALL nemo_RK3        ! 3rd order Runge-Kutta
+      !
+      !
+      IF( ln_diaobs   )   CALL dia_obs_wri
+      !
+      IF( ln_icebergs )   CALL icb_end( nitend )
+
+      !                            !------------------------!
+      !                            !==  finalize the run  ==!
+      !                            !------------------------!
+      IF(lwp) WRITE(numout,cform_aaa)        ! Flag AAAAAAA
+      !
+      IF( nstop /= 0 .AND. lwp ) THEN        ! error print
+         WRITE(numout,cform_err)
+         WRITE(numout,*) '   ==>>>   nemo_gcm: a total of ', nstop, ' errors have been found'
+         WRITE(numout,*)
+      ENDIF
+      !
+      IF( ln_timing )   CALL timing_finalize
+      !
+      CALL nemo_closefile
+      !
+#if defined key_iomput
+                                    CALL xios_finalize  ! end mpp communications with xios
+      IF( lk_oasis     )            CALL cpl_finalize   ! end coupling and mpp communications with OASIS
+#else
+      IF    ( lk_oasis ) THEN   ;   CALL cpl_finalize   ! end coupling and mpp communications with OASIS
+      ELSEIF( lk_mpp   ) THEN   ;   CALL mppstop        ! end mpp communications
+      ENDIF
+#endif
+      !
+   END SUBROUTINE nemo_gcm
+
+
+   SUBROUTINE nemo_MLF
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE nemo_MLF  ***
+      !!
+      !! ** Purpose :   Modified Leap-Frog time stepping loop
+      !!----------------------------------------------------------------------
+      INTEGER ::   istp   ! time step index
+      !!----------------------------------------------------------------------
+      !                                               !== set the MLF time-step  ==!
       !
       IF( l_1st_euler ) THEN   ;   rDt =         rn_Dt   ;   l_1st_euler = .TRUE.    ! start or restart with Euler 1st time-step
@@ -212,33 +257,50 @@
 #endif
       !
-      IF( ln_diaobs   )   CALL dia_obs_wri
-      !
-      IF( ln_icebergs )   CALL icb_end( nitend )
-
-      !                            !------------------------!
-      !                            !==  finalize the run  ==!
-      !                            !------------------------!
-      IF(lwp) WRITE(numout,cform_aaa)        ! Flag AAAAAAA
-      !
-      IF( nstop /= 0 .AND. lwp ) THEN        ! error print
-         WRITE(numout,cform_err)
-         WRITE(numout,*) '   ==>>>   nemo_gcm: a total of ', nstop, ' errors have been found'
-         WRITE(numout,*)
-      ENDIF
-      !
-      IF( ln_timing )   CALL timing_finalize
-      !
-      CALL nemo_closefile
-      !
-#if defined key_iomput
-                                    CALL xios_finalize  ! end mpp communications with xios
-      IF( lk_oasis     )            CALL cpl_finalize   ! end coupling and mpp communications with OASIS
+   END SUBROUTINE nemo_MLF
+
+
+   SUBROUTINE nemo_RK3
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE nemo_RK3  ***
+      !!
+      !! ** Purpose :   3rd order Runge-Kutta time stepping loop
+      !!----------------------------------------------------------------------
+      INTEGER ::   istp   ! time step index
+      !!----------------------------------------------------------------------
+      !
+      !                                         !== set the model time-step  ==!
+      rDt = rn_Dt
+      r1_Dt = 1._wp / rDt
+      istp = nit000
+      !
+#if defined key_agrif
+      !                                         !==  AGRIF time-stepping  ==!
+      CALL Agrif_Regrid()
+      !
+      CALL Agrif_step_child_adj(Agrif_Update_All)        ! Recursive update from highest to lowest nested levels
+      !
+      DO WHILE( istp <= nitend .AND. nstop == 0 )
+         CALL stp_RK3
+         istp = istp + 1
+      END DO
+      !
+      IF( .NOT. Agrif_Root() ) THEN
+         CALL Agrif_ParentGrid_To_ChildGrid()
+         IF( ln_diaobs )   CALL dia_obs_wri
+         IF( ln_timing )   CALL timing_finalize
+         CALL Agrif_ChildGrid_To_ParentGrid()
+      ENDIF
+      !
 #else
-      IF    ( lk_oasis ) THEN   ;   CALL cpl_finalize   ! end coupling and mpp communications with OASIS
-      ELSEIF( lk_mpp   ) THEN   ;   CALL mppstop        ! end mpp communications
-      ENDIF
-#endif
-      !
-   END SUBROUTINE nemo_gcm
+      !                                         !==  Standard time-stepping  ==!
+      !
+      DO WHILE( istp <= nitend .AND. nstop == 0 )
+         CALL stp_RK3( istp ) 
+         istp = istp + 1
+      END DO
+      !
+#endif
+      !
+   END SUBROUTINE nemo_RK3
 
 
@@ -459,5 +521,12 @@
 
       !                                      ! Assimilation increments
-      IF( lk_asminc    )   CALL asm_inc_init    ! Initialize assimilation increments
+      IF( lk_asminc    ) THEN
+                           CALL asm_inc_init    ! Initialize assimilation increments
+                           l_dynasm = ln_asmiau .AND. ln_dyninc
+                           l_traasm = ln_asmiau .AND. ln_trainc
+      ELSE
+                           l_dynasm = .FALSE.
+                           l_traasm = .FALSE.
+      ENDIF
       !
       IF(lwp) WRITE(numout,cform_aaa)           ! Flag AAAAAAA
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/oce.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/oce.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/oce.F90	(revision 10001)
@@ -34,5 +34,8 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   ub_b   ,  un_b  ,  ua_b  !: Barotropic velocities at u-point [m/s]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   vb_b   ,  vn_b  ,  va_b  !: Barotropic velocities at v-point [m/s]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   sshb   ,  sshn  ,  ssha  !: sea surface height at t-point [m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   sshb   ,  sshn  , ssha   !: sea surface height at t-point [m]
+
+!!gm??   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ssh  , sshu   , sshv   !: sea surface height at t-, u- v-points [m]
+
 
    !! Arrays at barotropic time step:                   ! befbefore! before !  now   ! after  !
@@ -90,5 +93,5 @@
          &      rhd  (jpi,jpj,jpk)      , rhop (jpi,jpj,jpk)                              , STAT=ierr(1) )
          !
-      ALLOCATE( sshb(jpi,jpj)     , sshn(jpi,jpj)   , ssha(jpi,jpj)   ,     &
+      ALLOCATE( sshb  (jpi,jpj)  , sshn   (jpi,jpj) , ssha(jpi,jpj)   ,     &
          &      ub_b(jpi,jpj)     , un_b(jpi,jpj)   , ua_b(jpi,jpj)   ,     &
          &      vb_b(jpi,jpj)     , vn_b(jpi,jpj)   , va_b(jpi,jpj)   ,     &
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/par_oce.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/par_oce.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/par_oce.F90	(revision 10001)
@@ -12,4 +12,12 @@
    IMPLICIT NONE
    PUBLIC
+
+
+   !!
+   INTEGER, PUBLIC ::   Nnn, Np1, Nm1   ! =now, before, after
+
+   INTEGER, PUBLIC ::   Nb, Nn, Na      ! before, now, after  index
+
+
 
    !!----------------------------------------------------------------------
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/step.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/step.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/step.F90	(revision 10001)
@@ -179,6 +179,5 @@
                          va(:,:,:) = 0._wp
 
-      IF(  lk_asminc .AND. ln_asmiau .AND. ln_dyninc )   &
-               &         CALL dyn_asm_inc   ( kstp )  ! apply dynamics assimilation increment
+      IF( l_dynasm   )   CALL dyn_asm_inc   ( kstp )  ! apply dynamics assimilation increment
       IF( ln_bdy     )   CALL bdy_dyn3d_dmp ( kstp )  ! bdy damping trends
 #if defined key_agrif
@@ -232,6 +231,5 @@
                          tsa(:,:,:,:) = 0._wp         ! set tracer trends to zero
 
-      IF(  lk_asminc .AND. ln_asmiau .AND. &
-         & ln_trainc )   CALL tra_asm_inc   ( kstp )  ! apply tracer assimilation increment
+      IF(  l_traasm  )   CALL tra_asm_inc   ( kstp )  ! apply tracer assimilation increment
                          CALL tra_sbc       ( kstp )  ! surface boundary condition
       IF( ln_traqsr  )   CALL tra_qsr       ( kstp )  ! penetrative solar radiation qsr
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/step_oce.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/step_oce.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/step_oce.F90	(revision 10001)
@@ -108,4 +108,5 @@
 #if defined key_top
    USE trcstp           ! passive tracer time-stepping      (trc_stp routine)
+   USE trcadv           ! passive tracer time-stepping      (trc_stp routine)
 #endif
    !!----------------------------------------------------------------------
